package edu.uog.exercise.unitconverter.todolist;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.TextView;
import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;
import java.util.List;
import edu.uog.exercise.unitconverter.R;


public class ToDoAdapter extends RecyclerView.Adapter<ToDoAdapter.ViewHolder> {
    public interface ClickListener {
        void onItemClick(int position, View v, long id);
    }
    public void setListener(ClickListener listener){
        this.listener =listener;
    }
    private static ClickListener listener;
    private List<ToDoItem> toDoList;
    public void setTodoList(List<ToDoItem> toDoList){
        this.toDoList =toDoList;
    }
    public ToDoAdapter(List<ToDoItem> toDoList ){
        this.toDoList =toDoList;
    }
    @NonNull
    @Override
    public ViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext())
                .inflate(R.layout.todo_item, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ViewHolder holder, int position) {
        ToDoItem toDoItem =toDoList.get(position);
        holder.lblName.setText(toDoItem.getName());
        holder.btnDone.setVisibility(View.GONE);

//        if( toDoItem.getStatus().equals(ToDoItem.STATUS_COMPLETED)){
//            holder.btnDone.setVisibility(View.GONE);
//        }else{
//            holder.btnDone.setVisibility(View.VISIBLE);
//        }
    }

    @Override
    public int getItemCount() {
        return toDoList.size();
    }

    public static class ViewHolder extends RecyclerView.ViewHolder{
        TextView lblName;
        Button btnRemove;
        Button btnEdit;
        Button btnDone;

        public ViewHolder(@NonNull View itemView) {
            super(itemView);
            lblName =itemView.findViewById(R.id.lblName);
            btnDone =itemView.findViewById(R.id.btnDone);
            btnRemove =itemView.findViewById(R.id.btnRemove);
            btnRemove.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    listener.onItemClick(getAdapterPosition(), view, R.id.btnRemove);
                }
            });
            btnEdit =itemView.findViewById(R.id.btnEdit);
            btnEdit.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    listener.onItemClick(getAdapterPosition(), view, R.id.btnEdit);
                }
            });

            btnDone =itemView.findViewById(R.id.btnDone);
            btnDone.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View view) {
                    listener.onItemClick(getAdapterPosition(), view, R.id.btnDone);
                }
            });
        }
    }
}
