package edu.uog.exercise.unitconverter.todolist;

import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import java.util.ArrayList;
import java.util.List;
import edu.uog.exercise.unitconverter.R;


public class ToDoListActivity extends AppCompatActivity {

    private List<ToDoItem> toDoList =new ArrayList<>();
    private ToDoAdapter toDoAdapter;
    ToDoItem toDoItem = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_to_do_list);

        RecyclerView recyclerView =findViewById(R.id.lstView);
        recyclerView.setLayoutManager(new LinearLayoutManager(this));
        toDoAdapter =new ToDoAdapter( toDoList );
        toDoAdapter.setListener(new ToDoAdapter.ClickListener() {
            @Override
            public void onItemClick(int position, View v, long id) {
                if (id == R.id.btnRemove ){
                    toDoList.remove(position);
                    toDoAdapter.setTodoList(toDoList);
                    toDoAdapter.notifyDataSetChanged();
                }else if (id == R.id.btnEdit ){
                    toDoItem = toDoList.get(position);
                    editRecord( toDoItem, position );
                }else if (id == R.id.btnDone ){
                    toDoItem = toDoList.get(position);
                    toDoItem.setStatus(ToDoItem.STATUS_COMPLETED);
                    toDoAdapter.setTodoList(toDoList);
                    toDoAdapter.notifyDataSetChanged();
                }

            }
        });
        recyclerView.setAdapter(toDoAdapter);
    }

    public void addRecord(View view){
        AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(ToDoListActivity.this);

        android.view.LayoutInflater inflater = this.getLayoutInflater();
        View dialogView = inflater.inflate(R.layout.todo_dialog, null);
        dialogBuilder.setView(dialogView);

        EditText txtName = dialogView.findViewById(R.id.txtName);
        EditText txtDescription = dialogView.findViewById(R.id.txtDescription);

        dialogBuilder.setTitle("Add todo");
        dialogBuilder.setMessage("Enter data below");
        dialogBuilder.setPositiveButton("Add", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                int id = toDoList.size()==0? 1: toDoList.get(toDoList.size()-1).getId() + 1;
                toDoItem = new ToDoItem( id,
                        txtName.getText().toString(), txtDescription.getText().toString(), ToDoItem.STATUS_TODO);
                toDoList.add(toDoItem);
                toDoAdapter.setTodoList(toDoList);
                toDoAdapter.notifyDataSetChanged();
            }
        });
        dialogBuilder.setNegativeButton("Cancel", null);
        AlertDialog alertDialog = dialogBuilder.create();
        alertDialog.show();
    }

    public void editRecord(final ToDoItem toDoItem, int position){
        AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(ToDoListActivity.this);

        android.view.LayoutInflater inflater = this.getLayoutInflater();
        View dialogView = inflater.inflate(R.layout.todo_dialog, null);
        dialogBuilder.setView(dialogView);

        EditText txtName = dialogView.findViewById(R.id.txtName);
        txtName.setText(toDoItem.getName());
        EditText txtDescription = dialogView.findViewById(R.id.txtDescription);
        txtDescription.setText(toDoItem.getTask());

        dialogBuilder.setTitle("Edit todo");
        dialogBuilder.setMessage("Update data below");
        dialogBuilder.setPositiveButton("Update", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                toDoItem.setName( txtName.getText().toString() );
                toDoItem.setTask( txtDescription.getText().toString() );

                toDoList.set(position, toDoItem);
                toDoAdapter.setTodoList(toDoList);
                toDoAdapter.notifyDataSetChanged();
            }
        });
        dialogBuilder.setNegativeButton("Cancel", null);
        AlertDialog alertDialog = dialogBuilder.create();
        alertDialog.show();
    }
}